//
// This is a part of e-sushi module sourcecode
// for Litestep, a replacement shell.
// Copyright (C) 2002 Mike Edward Moras / e-sushi
//
// This program is free software;
// you can redistribute it and/or modify it under
// the terms of the GNU General Public License
// as published by the Free Software Foundation;
// either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it
// will be useful, but WITHOUT ANY WARRANTY; without
// even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.
// See the GNU General Public License for more details.
//
// You should have received a copy of the
// GNU General Public License along with this program;
// if not, write to: Free Software Foundation, Inc.
//                   59 Temple Place - Suite 330
//                   Boston
//                   MA  02111-1307, USA.
//
/*
!PANIC

  this bang closes ALL currently
  open windows and applications.
*/

#define WIN32_LEAN_AND_MEAN
#include "../lsapi/lsapi.h"

#include <windows.h>
#include <windowsx.h>

void bangPanic(HWND caller, LPCSTR args);

	
extern "C" {
    __declspec( dllexport ) int initModuleEx(HWND parent, HINSTANCE dll, LPCSTR szPath);
    __declspec( dllexport ) void quitModule(HINSTANCE dllInst);
}

int initModuleEx(HWND parentWnd, HINSTANCE dllInst, LPCSTR szPath)
{
    int code = 0;
    AddBangCommand("!PANIC", bangPanic);
	return code;
}

void quitModule(HINSTANCE dllInst)
{
    RemoveBangCommand("!PANIC");

}


BOOL CALLBACK EnumWindowsProc( HWND hwnd, LPARAM lParam)
{
    long style;

    if(IsWindowVisible(hwnd))
    {
        style=GetWindowLong(hwnd,GWL_STYLE);
        if(style & WS_OVERLAPPEDWINDOW &&
            (style & WS_POPUP)== false)
        {
			PostMessage(hwnd,WM_CLOSE,0,0);
        }
    }
    
    return true;
}
 

void bangPanic(HWND caller, LPCSTR args)
{
    EnumWindows(EnumWindowsProc,0);
}







